package  
{
	import org.flixel.*;
	import org.flixel.plugin.photonstorm.*;
	/**
	 * ...
	 * @author rawktron
	 */
	public class Monster extends FlxSprite
	{
		public var bCanAttack:Boolean;
		public var attackTimer:FlxTimer;
		public var spawnpoint:FlxPoint;
		[Embed(source = "../data/Monster.png")] private var ImgMonster:Class;

		public function Monster(sx:Number,sy:Number) 
		{
			loadGraphic(ImgMonster, true, true, 8, 8);
			addAnimation("idle", [0], 0, true);
			addAnimation("move", [0, 1, 2, 3], 10, true);
			
			
			elasticity = 1.2;
			drag.x = 400;
			drag.y = 400;
			bCanAttack = true;
			x = sx;
			y = sy;
			
			spawnpoint = new FlxPoint(x, y);
			
		}
		
		override public function update():void
		{
			if (velocity.x > 0)
			{
				facing = RIGHT;
			}
			else
			{
				facing = LEFT;
			}
			
			if (velocity.x == 0 && velocity.y == 0)
			{
				play("idle");
			}
			else
			{
				play("move");
			}
		}
		
		public function onTimer(Timer:FlxTimer):void
		{
			if (!alive)
			{
				// It's alive!!!!
				this.reset(spawnpoint.x, spawnpoint.y);
			}
			else
			{
				bCanAttack = true;
				if (path)
				{
					followPath(path, 60, FlxObject.PATH_YOYO, false);
				}
			}
		}
		
		override public function kill():void
		{
			attackTimer = new FlxTimer();
			attackTimer.start(10, 1, onTimer);
			super.kill();
		}
		
		public function attacked():void
		{
			attackTimer = new FlxTimer();
			attackTimer.start(2, 1, onTimer);
			bCanAttack = false;
		}
	}

}