package

{

	import org.flixel.*;
	import org.flixel.plugin.photonstorm.*;
	import org.flixel.plugin.TimerManager;

	public class PlayState extends FlxState

	{
		[Embed(source="../data/mapCSV_Map_Triggers.csv",mimeType="application/octet-stream")] private var TxtTrig:Class;
		[Embed(source="../data/mapCSV_Map_Triggers.csv",mimeType="application/octet-stream")] private var TxtDest:Class;
		[Embed(source = "../data/Tiles.png")] private var ImgTiles:Class;
		[Embed(source = "../data/HUD.png")] private var ImgHUD:Class;
		[Embed(source="../data/mapCSV_Map_Wasteland.csv",mimeType="application/octet-stream")] private var TxtMap:Class;
		[Embed(source = "../data/BigExplode.mp3")] private var NukeSnd:Class;
		[Embed(source = "../data/Explosion1.mp3")] private var ExplodeSnd:Class;
		[Embed(source = "../data/Hurt.mp3")] private var HurtSnd:Class;
		[Embed(source = "../data/Swap.mp3")] private var TalismanSnd:Class;
		
		
		public var _map:FlxTilemap;
		public var _player:Player;
				
		public var _monsters:FlxGroup;
		public var _survivors:FlxGroup;
		public var _shrubs:FlxGroup;
		public var _dests:Array;
		public var _spch:FlxText;
		public var _qsur:Survivor;
		
		public var _killrange:int;
		public var _nukeusage:int;
		public var _scoretext:FlxText;
		public var _HUD:FlxSprite;
		
		public var hbar:FlxHealthBar;
	
		override public function create():void
		{
			_monsters = new FlxGroup();
			_survivors = new FlxGroup();
			_shrubs = new FlxGroup();
			
			_map = new FlxTilemap();
			_map.loadMap(new TxtMap, ImgTiles, 8, 8, FlxTilemap.OFF, 0, 1, 3);
			add(_map);

			_player = new Player();
			add(_player);
			_qsur = null;
			_killrange = 120;
			_nukeusage = 0;
			FlxG.score = 0;
			// More HUD

			_HUD = new FlxSprite(230, 0);
			_HUD.loadGraphic(ImgHUD, true, false, 8, 8);
			_HUD.addAnimation("on", [0], 0, true);
			_HUD.addAnimation("off", [1], 0, true);
			add(_HUD);
			
			_spch = new FlxText(_player.x, _player.y - 8, 200, "It's dangerous to go alone. Take this!", true);
			_spch.visible = false;
			hbar = new FlxHealthBar(_player, 50, 8);
			hbar.x = 120;
			hbar.y = 0;
			hbar.scrollFactor.x = 0;
			hbar.scrollFactor.y = 0;
			
			var ft:FlxText = new FlxText(80, -2, 100, "Health", true);
			ft.size = 7;
			add(ft);
			_scoretext = new FlxText(180, -2, 100, "Score: "+FlxG.score, true);
			_scoretext.size = 7;
			add(_scoretext);
			
			add(hbar);			
			
			_dests = new Array();
			
			var tmpdest:String = new TxtDest;
			var rw:Array = tmpdest.split("\n");
			for ( var yy:uint = 0; yy < rw.length; yy++ )
			{
				var cl:Array = rw[yy].split(",");
				for ( var xx:uint = 0; xx < cl.length; xx++ )
				{
					if (cl[xx] == "3")
					{
						var pt:FlxPoint;
						
						pt = new FlxPoint(xx * 8, yy * 8);
						_dests.push(pt);
					}
				}
			}
			
			
			var tmpmap:String = new TxtTrig;
			var rows:Array = tmpmap.split("\n");
			for ( var t:uint = 0; t < rows.length; t++ )
			{
				var cols:Array = rows[t].split(",");
				for ( var s:uint = 0; s < cols.length; s++ )
				{
					if (cols[s] == "1")
					{
						// Survivor
						var survivor:Survivor;
						survivor = new Survivor();
						survivor.x = s*8;
						survivor.y = t*8;
						
						
						_survivors.add(survivor);
						_shrubs.add(new Shrub(survivor.x, survivor.y));
						
					}
					if (cols[s] == "2")
					{
						// Monster
						// Normally I guess we'd loop through trigger points above or something
						var monster:Monster;
						
						monster = new Monster(s*8,t*8);
						
						// Only some monsers wander
						if (FlxMath.chanceRoll(50))
						{
							var sp:FlxPoint;
							var wp:FlxPoint;
							
							sp = new FlxPoint(monster.x, monster.y);
							// TODO: Find a free square within radius r
							wp = findClosest(sp);
							if (wp)
							{
								var p:FlxPath = _map.findPath(sp, wp);
								if (p)
								{
									monster.followPath(p, 60, FlxObject.PATH_YOYO,false);
								}
							}
						}
						else
						{
							_shrubs.add(new Shrub(monster.x, monster.y));
						}
						
						_monsters.add(monster);
					}
					if (cols[s] == "4")
					{
						var shrub:Shrub;
						
						shrub = new Shrub(s * 8, t * 8);
						
						_shrubs.add(shrub);
					}
				}
			}
			// Add Monsters
			add(_monsters);
			
			// Add the survivors
			add(_survivors);
			
			add(_shrubs);
			add(_spch);
			
			FlxG.camera.setBounds(0, 0, _map.width, _map.height, true);
			FlxG.camera.follow(_player,FlxCamera.STYLE_LOCKON);			
			
			//FlxG.mouse.show();
		}
		
		public function findClosest(pt:FlxPoint):FlxPoint
		{
			// find the closest destination point to the one passed in
			var dist:Number = 999999999;
			var idx:int = -1;
			for (var i:uint = 0; i < _dests.length; i++)
			{
				var td:Number;
				td = FlxU.getDistance(pt, _dests[i]);
				if (td < dist)
				{
					idx = i;
					dist = td;
				}
			}
			
			if (idx >= 0)
			{
				return _dests[idx];
			}
			
			return null;
		}
		
		public function onGameOver(Timer:FlxTimer):void
		{
			FlxG.switchState(new GameOverState());
		}
		
		public function onSpeech(Timer:FlxTimer):void
		{
			_spch.visible = false;
			_player.Takeover(_qsur);
		}
		
		override public function update():void
		{
			_scoretext.text = "Score: " + FlxG.score;
			
			if (_player.bCanNuke)
			{
				_HUD.play("on");

			}
			else
			{
				_HUD.play("off");
			}
			// Let's process the monsters
			for (var m:int = 0; m < _monsters.length; m++)
			{
				var enemy:Monster = _monsters.members[m];
				// Check if player is within range of any monsters
				var ppos:FlxPoint = new FlxPoint(_player.x, _player.y);
				var epos:FlxPoint = new FlxPoint(enemy.x, enemy.y);
				var dist:Number = FlxU.getDistance(ppos,epos);
				
				// Some value to be tweaked
				if (dist < 16 && enemy.bCanAttack && enemy.alive)
				{
					// now raycast to make sure there's nothing to block the monster's attack
					var result:FlxPoint;
					if (_map.ray(epos, ppos, result, 1))
					{
						if (enemy.path)
						{
							enemy.stopFollowingPath();
						}
						// ATTACK!!!!!!
						FlxVelocity.moveTowardsObject(enemy, _player, 200, 0);
						enemy.attacked();
					}
				}
			}
			
			FlxG.collide(_map, _player);
			FlxG.collide(_map, _monsters);
			FlxG.collide(_monsters, _survivors);
			FlxG.collide(_map, _survivors);
			FlxG.collide(_player, _survivors);
			FlxG.collide(_player, _shrubs);
			
			if (FlxG.collide(_player, _monsters))
			{
				_player.hurt(4);
				FlxG.play(HurtSnd, 1.0);
			}

			
			if (FlxG.keys.X && _player.bCanNuke)
			{
				// Nuke!
				_killrange = 120 - (20 * _nukeusage);
				if (_killrange < 16)
				{
					_killrange = 16;
				}
				
				_nukeusage++;
				_player.bCanNuke = false;
				_player.healthTime = 0.5;
				_player.healthTimer.stop();
				_player.healthTimer.destroy();
				_player.healthTimer = new FlxTimer();
				_player.healthTimer.start(_player.healthTime, _player.health, _player.onTimer);

				if (_survivors.countLiving() == 0)
				{
					FlxG.flash(0xffffffff, 5);
					FlxG.shake(0.05, 5);
					FlxG.play(NukeSnd, 1.0);
				}
				else
				{
					FlxG.flash();
					FlxG.shake(0.05, 1);
					FlxG.play(ExplodeSnd, 1.0);
				}
				for (m = 0; m < _monsters.length; m++)
				{
					enemy = _monsters.members[m];
					// Check if player is within range of any monsters
					ppos = new FlxPoint(_player.x, _player.y);
					epos = new FlxPoint(enemy.x, enemy.y);
					dist = FlxU.getDistance(ppos,epos);
					if (dist < _killrange && enemy.alive)
					{
						enemy.kill();
					}
				}
				
				if (_survivors.countLiving() == 0)
				{
					// There are none left! We have just fallen on the grenade.
					_player.kill();
					FlxG.score++;
				}
				
			}
			
			if (FlxG.keys.C)
			{
				for (m = 0; m < _survivors.length; m++)
				{
					var sur:Survivor = _survivors.members[m];
					var spos:FlxPoint = new FlxPoint(sur.x, sur.y);
					var near:Number = FlxU.getDistance(ppos,spos);
					
					if (near < 16 && sur.alive)
					{
						FlxG.play(TalismanSnd, 1.0);
						_player.Takeover(sur);
						
						//_spch.x = _player.x;
						//_spch.y = _player.y-10;
						//_spch.size = 8;
						//_spch.visible = true;
						//
						//_qsur = sur;
						//var delay:FlxTimer;
						//
						//delay = new FlxTimer();
						//delay.start(2, 1, onSpeech);
					}
				}
			}
			
			if (FlxG.keys.justPressed("M"))
			{
				if (FlxG.mute)
				{
					FlxG.mute = false;
				}
				else
				{
					FlxG.mute = true;
				}
			}
			
			// Game over/restart type dillyo
			if (!_player.alive)
			{
				var deathTimer:FlxTimer;
				
				deathTimer = new FlxTimer();
				deathTimer.start(5, 1, onGameOver);
			}
			
			super.update();
		}

	}

}

